
if (!window['Smart']) {
	window['Smart'] = { RenderMode: 'manual' };
}
else {
	window['Smart'].RenderMode = 'manual';
}
import './../source/modules/smart.colorpanel';

import { __decorate, __extends } from 'tslib';
import { EventEmitter, Output, Input, forwardRef, ElementRef, Directive, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

var BaseElement = /** @class */ (function () {
    function BaseElement(ref) {
        this.onCreate = new EventEmitter();
        this.onReady = new EventEmitter();
        this.onAttach = new EventEmitter();
        this.onDetach = new EventEmitter();
        var that = this;
        this.nativeElement = ref.nativeElement;
        that.nativeElement.onAttached = function () {
            that.onAttach.emit(that.nativeElement);
        };
        that.nativeElement.onDetached = function () {
            that.onDetach.emit(that.nativeElement);
        };
    }
    BaseElement.prototype.addEventListener = function (type, listener, options) {
        if (options === void 0) { options = false; }
        this.nativeElement.addEventListener(type, listener, options);
    };
    BaseElement.prototype.removeEventListener = function (type, listener, options) {
        if (options === void 0) { options = false; }
        this.nativeElement.removeEventListener(type, listener, options);
    };
    BaseElement.prototype.dispatchEvent = function (event) {
        return this.nativeElement.dispatchEvent(event);
    };
    BaseElement.prototype.blur = function () {
        this.nativeElement.blur();
    };
    BaseElement.prototype.click = function () {
        this.nativeElement.click();
    };
    BaseElement.prototype.focus = function (options) {
        this.nativeElement.focus(options);
    };
    Object.defineProperty(BaseElement.prototype, "locale", {
        /** @description Sets or gets the language. Used in conjunction with the property messages.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.locale : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.locale = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "localizeFormatFunction", {
        /** @description Callback used to customize the format of the messages that are returned from the Localization Module. */
        get: function () {
            return this.nativeElement ? this.nativeElement.localizeFormatFunction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.localizeFormatFunction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "messages", {
        /** @description Sets or gets an object specifying strings used in the widget that can be localized. Used in conjunction with the property locale.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.messages : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.messages = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "rightToLeft", {
        /** @description Sets or gets the value indicating whether the element is aligned to support locales using right-to-left fonts. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rightToLeft : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rightToLeft = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "theme", {
        /** @description Determines the theme. Theme defines the look of the element */
        get: function () {
            return this.nativeElement ? this.nativeElement.theme : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.theme = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Output()
    ], BaseElement.prototype, "onCreate", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onReady", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onAttach", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onDetach", void 0);
    __decorate([
        Input()
    ], BaseElement.prototype, "locale", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "localizeFormatFunction", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "messages", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "rightToLeft", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "theme", null);
    return BaseElement;
}());
var Smart = window.Smart;

var CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(function () { return ColorPanelComponent; }),
    multi: true
};
var ColorPanelComponent = /** @class */ (function (_super) {
    __extends(ColorPanelComponent, _super);
    function ColorPanelComponent(ref) {
        var _this = _super.call(this, ref) || this;
        _this.eventHandlers = [];
        /**
        * @description
        * The registered callback function called when a change event occurs on the form elements.
        */
        _this._onChange = function () { };
        /**
        * @description
        * The registered callback function called when a blur event occurs on the form elements.
        */
        _this._onTouched = function () { };
        /** @description This event is triggered when the color is changed.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	oldValue, 	value)
        *   oldValue - The previously selected color.
        *   value - The new selected color.
        */
        _this.onChange = new EventEmitter();
        /** @description This event is triggered when the cancel button is clicked. 'Cancel' button is visible only when applyValueMode is set to useButtons.
        *  @param event. The custom event. 	*/
        _this.onCancelButtonClick = new EventEmitter();
        /** @description This event is triggered when the custom color selection view is opened/closed. Custom color selection view is available when enableCustomColors property is true.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	value)
        *   value - A boolean that indicates whether the custom color view is shown or not.
        */
        _this.onCustomColorSelection = new EventEmitter();
        /** @description This event is triggered when the ok button is clicked. 'Ok' button is visible only when applyValueMode is set to useButtons.
        *  @param event. The custom event. 	*/
        _this.onOkButtonClick = new EventEmitter();
        _this._initialChange = true;
        _this.nativeElement = ref.nativeElement;
        return _this;
    }
    /** @description Creates the component on demand.
     * @param properties An optional object of properties, which will be added to the template binded ones.
     */
    ColorPanelComponent.prototype.createComponent = function (properties) {
        if (properties === void 0) { properties = {}; }
        this.nativeElement = document.createElement('smart-color-panel');
        for (var propertyName in properties) {
            this.nativeElement[propertyName] = properties[propertyName];
        }
        return this.nativeElement;
    };
    Object.defineProperty(ColorPanelComponent.prototype, "animation", {
        /** @description Sets or gets the animation mode. Animation is disabled when the property is set to 'none' */
        get: function () {
            return this.nativeElement ? this.nativeElement.animation : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.animation = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "applyValueMode", {
        /** @description Specifies how the value is applied. */
        get: function () {
            return this.nativeElement ? this.nativeElement.applyValueMode : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.applyValueMode = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "columnCount", {
        /** @description Defines the number of columns for the colors in displayModes 'grid', 'hexagonal' and 'spectrumGrid'. */
        get: function () {
            return this.nativeElement ? this.nativeElement.columnCount : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.columnCount = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "disabled", {
        /** @description Enables or disables the element. Disabled elements can not be interacted with. */
        get: function () {
            return this.nativeElement ? this.nativeElement.disabled : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.disabled = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "displayMode", {
        /** @description Determines the colors that will be displayed and their layout. */
        get: function () {
            return this.nativeElement ? this.nativeElement.displayMode : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.displayMode = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "disableUndo", {
        /** @description By default clicking on color panel's preview container returns the color value to it's previous state. 'disableUndo' prevents this functionality. */
        get: function () {
            return this.nativeElement ? this.nativeElement.disableUndo : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.disableUndo = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "editAlphaChannel", {
        /** @description Allows to edit the alpha(transparency) of the colors via an editor/slider in the following displayModes: 'palette', 'radial', 'hexagonal' */
        get: function () {
            return this.nativeElement ? this.nativeElement.editAlphaChannel : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.editAlphaChannel = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "enableCustomColors", {
        /** @description Allows to select a custom color via an editor popup. Custom color selection is available in modes that don't have this option by default, like: 'grid', 'default, 'spectrum grid'. */
        get: function () {
            return this.nativeElement ? this.nativeElement.enableCustomColors : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.enableCustomColors = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "gridThemeColors", {
        /** @description Defines an Array of colors that will be used as the Theme Colors in the corresponding section in displayMode: 'default'. */
        get: function () {
            return this.nativeElement ? this.nativeElement.gridThemeColors : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.gridThemeColors = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "gridShadeColors", {
        /** @description Defines an Array of colors that will be used as the Shade Colors in the corresponding section of displayMode: 'default'. */
        get: function () {
            return this.nativeElement ? this.nativeElement.gridShadeColors : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.gridShadeColors = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "gridStandardColors", {
        /** @description Defines an Array of colors that will be used as the Standart Colors in the corresponding section of displayMode: 'default'. */
        get: function () {
            return this.nativeElement ? this.nativeElement.gridStandardColors : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.gridStandardColors = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "hideAlphaEditor", {
        /** @description Hides the alpha editor. Alpha editor is an input containing the value of the current color opacity. The input is available in the following modes: 'radial', 'palette', 'hexagonal'. The input is only visible if there's enough space. This editor is visible by default. */
        get: function () {
            return this.nativeElement ? this.nativeElement.hideAlphaEditor : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.hideAlphaEditor = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "hideContentToFit", {
        /** @description Determines which color editors will be hidden first when there's not enough space for all of them to be visible. By default the editors are only visible in 'palette', 'radial' and 'hexagonal' display modes. This property allows to prioritize the visibility of the editors. */
        get: function () {
            return this.nativeElement ? this.nativeElement.hideContentToFit : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.hideContentToFit = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "hideHEXEditor", {
        /** @description HEX editor is an input containing the hexadecimal representation of a color. This editor is visible by default. Setting 'hideRGBeditor' to true hides it. */
        get: function () {
            return this.nativeElement ? this.nativeElement.hideHEXEditor : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.hideHEXEditor = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "hidePreviewContainer", {
        /** @description Hides the preview container. Preview container is used to show the currently selected value in 'palette', 'radial' and 'hexagonal' display modes. */
        get: function () {
            return this.nativeElement ? this.nativeElement.hidePreviewContainer : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.hidePreviewContainer = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "hideRGBEditor", {
        /** @description Hides the RGB editor. This editor is a group of three separate inputs for the Red, Green and Blue values of the color. */
        get: function () {
            return this.nativeElement ? this.nativeElement.hideRGBEditor : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.hideRGBEditor = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "inverted", {
        /** @description Inverts the colors in 'spectrumGrid', 'hexagonal', 'radial' modes. */
        get: function () {
            return this.nativeElement ? this.nativeElement.inverted : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.inverted = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "locale", {
        /** @description Sets or gets the language. Used in conjunction with the property messages. */
        get: function () {
            return this.nativeElement ? this.nativeElement.locale : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.locale = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "localizeFormatFunction", {
        /** @description Callback used to customize the format of the messages that are returned from the Localization Module. */
        get: function () {
            return this.nativeElement ? this.nativeElement.localizeFormatFunction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.localizeFormatFunction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "messages", {
        /** @description Sets or gets an object specifying strings used in the widget that can be localized. Used in conjunction with the property locale.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.messages : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.messages = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "name", {
        /** @description Sets or gets the name attribute for the element. Name is used when submiting HTML forms. */
        get: function () {
            return this.nativeElement ? this.nativeElement.name : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.name = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "palette", {
        /** @description Determines what colors will be displayed in 'spectrumGrid', 'grid' and 'hexagonal' displayModes. */
        get: function () {
            return this.nativeElement ? this.nativeElement.palette : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.palette = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "paletteColors", {
        /** @description Defines an array of colors that form a custom palette. This palette can be used in displayModes 'grid' and 'spectrum grid' if the palette property is set to custom. The value of the property can be an array of strings or objects that contain valid colors ( HEX, RGBA, etc). */
        get: function () {
            return this.nativeElement ? this.nativeElement.paletteColors : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.paletteColors = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "paletteCustomColors", {
        /** @description Defines an array of colors that represent a predefined list of custom colors. This palette can be used in displayModes 'grid', 'default' and 'spectrum grid'. Custom colors are displayed at the bottom of the color grid below the button for custom color selection. They are only visible if enableCustomColors property is true. */
        get: function () {
            return this.nativeElement ? this.nativeElement.paletteCustomColors : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.paletteCustomColors = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "readonly", {
        /** @description If the element is readonly, users cannot interact with it. */
        get: function () {
            return this.nativeElement ? this.nativeElement.readonly : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.readonly = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "rightToLeft", {
        /** @description Sets or gets the value indicating whether the element is aligned to support locales using right-to-left fonts. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rightToLeft : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rightToLeft = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "theme", {
        /** @description Determines the theme. Theme defines the look of the element */
        get: function () {
            return this.nativeElement ? this.nativeElement.theme : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.theme = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "tooltipDisplayMode", {
        /** @description Determines how the tooltip displays the value of the color that is being hovered. */
        get: function () {
            return this.nativeElement ? this.nativeElement.tooltipDisplayMode : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.tooltipDisplayMode = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "value", {
        /** @description Represents the value of the selected color. */
        get: function () {
            return this.nativeElement ? this.nativeElement.value : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.value = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "valueFormat", {
        /** @description Determines the format of the color. Whether it's in HEX, RGB or RGBA. By default it shows the color depending on the displayMode. */
        get: function () {
            return this.nativeElement ? this.nativeElement.valueFormat : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.valueFormat = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "valueMember", {
        /** @description Determines the value member for the color when the paletteColors consists of objects. Usefull in cases where the colors are loaded as objects in an array and the attribute that holds the color key is not named 'value'. */
        get: function () {
            return this.nativeElement ? this.nativeElement.valueMember : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.valueMember = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "unfocusable", {
        /** @description If is set to true, the element cannot be focused. */
        get: function () {
            return this.nativeElement ? this.nativeElement.unfocusable : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.unfocusable = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorPanelComponent.prototype, "isRendered", {
        get: function () {
            return this.nativeElement ? this.nativeElement.isRendered : false;
        },
        enumerable: true,
        configurable: true
    });
    ColorPanelComponent.prototype.ngOnInit = function () {
    };
    ColorPanelComponent.prototype.ngAfterViewInit = function () {
        var that = this;
        that.onCreate.emit(that.nativeElement);
        Smart.Render();
        this.nativeElement.classList.add('smart-angular');
        this.nativeElement.whenRendered(function () { that.onReady.emit(that.nativeElement); });
        this.listen();
    };
    ColorPanelComponent.prototype.ngOnDestroy = function () {
        this.unlisten();
    };
    Object.defineProperty(ColorPanelComponent.prototype, "ngValue", {
        get: function () {
            if (!this.nativeElement) {
                return null;
            }
            var value = this.nativeElement.value;
            return value;
        },
        set: function (value) {
            if (this.nativeElement) {
                this.writeValue(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ColorPanelComponent.prototype.writeValue = function (value) {
        var that = this;
        var normalizedValue = value == null ? '' : value;
        that.nativeElement.whenRendered(function () {
            that.value = normalizedValue;
            if (that._initialChange === false) {
                that._onChange(that.value);
            }
        });
    };
    ColorPanelComponent.prototype.registerOnChange = function (fn) {
        this._onChange = fn;
    };
    ColorPanelComponent.prototype.registerOnTouched = function (fn) {
        this._onTouched = fn;
    };
    ColorPanelComponent.prototype.ngOnChanges = function (changes) {
        if (this.nativeElement && this.nativeElement.isRendered) {
            for (var propName in changes) {
                if (changes.hasOwnProperty(propName)) {
                    this.nativeElement[propName] = changes[propName].currentValue;
                }
            }
        }
    };
    /** @description Add event listeners. */
    ColorPanelComponent.prototype.listen = function () {
        var that = this;
        that.eventHandlers['changeHandler'] = function (event) { that.onChange.emit(event); };
        that.nativeElement.addEventListener('change', that.eventHandlers['changeHandler']);
        that.eventHandlers['cancelButtonClickHandler'] = function (event) { that.onCancelButtonClick.emit(event); };
        that.nativeElement.addEventListener('cancelButtonClick', that.eventHandlers['cancelButtonClickHandler']);
        that.eventHandlers['customColorSelectionHandler'] = function (event) { that.onCustomColorSelection.emit(event); };
        that.nativeElement.addEventListener('customColorSelection', that.eventHandlers['customColorSelectionHandler']);
        that.eventHandlers['okButtonClickHandler'] = function (event) { that.onOkButtonClick.emit(event); };
        that.nativeElement.addEventListener('okButtonClick', that.eventHandlers['okButtonClickHandler']);
        that.eventHandlers['changeModelHandler'] = function (event) {
            that._initialChange = false;
            that._onChange(that.nativeElement.value);
        };
        that.eventHandlers['blurModelHandler'] = function (event) {
            that._onTouched();
        };
        that.nativeElement.whenRendered(function () {
            if (that.nativeElement.querySelector('input')) {
                that.eventHandlers['keyupModelHandler'] = function (event) {
                    setTimeout(function () { that.eventHandlers['changeModelHandler'](event); }, 50);
                };
                that.nativeElement.querySelector('input').addEventListener('keyup', that.eventHandlers['keyupModelHandler']);
            }
        });
        that.nativeElement.addEventListener('change', that.eventHandlers['changeModelHandler']);
        that.nativeElement.addEventListener('blur', that.eventHandlers['blurModelHandler']);
    };
    /** @description Remove event listeners. */
    ColorPanelComponent.prototype.unlisten = function () {
        var that = this;
        if (that.eventHandlers['changeHandler']) {
            that.nativeElement.removeEventListener('change', that.eventHandlers['changeHandler']);
        }
        if (that.eventHandlers['cancelButtonClickHandler']) {
            that.nativeElement.removeEventListener('cancelButtonClick', that.eventHandlers['cancelButtonClickHandler']);
        }
        if (that.eventHandlers['customColorSelectionHandler']) {
            that.nativeElement.removeEventListener('customColorSelection', that.eventHandlers['customColorSelectionHandler']);
        }
        if (that.eventHandlers['okButtonClickHandler']) {
            that.nativeElement.removeEventListener('okButtonClick', that.eventHandlers['okButtonClickHandler']);
        }
        if (that.eventHandlers['changeModelHandler']) {
            that.nativeElement.removeEventListener('change', that.eventHandlers['changeModelHandler']);
            if (that.nativeElement.querySelector('input')) {
                that.nativeElement.querySelector('input').removeEventListener('keyup', that.eventHandlers['keyupModelHandler']);
            }
        }
        if (that.eventHandlers['blurModelHandler']) {
            that.nativeElement.removeEventListener('blur', that.eventHandlers['blurModelHandler']);
        }
    };
    ColorPanelComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "animation", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "applyValueMode", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "columnCount", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "disabled", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "displayMode", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "disableUndo", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "editAlphaChannel", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "enableCustomColors", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "gridThemeColors", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "gridShadeColors", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "gridStandardColors", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "hideAlphaEditor", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "hideContentToFit", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "hideHEXEditor", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "hidePreviewContainer", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "hideRGBEditor", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "inverted", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "locale", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "localizeFormatFunction", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "messages", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "name", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "palette", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "paletteColors", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "paletteCustomColors", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "readonly", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "rightToLeft", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "theme", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "tooltipDisplayMode", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "value", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "valueFormat", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "valueMember", null);
    __decorate([
        Input()
    ], ColorPanelComponent.prototype, "unfocusable", null);
    __decorate([
        Output()
    ], ColorPanelComponent.prototype, "onChange", void 0);
    __decorate([
        Output()
    ], ColorPanelComponent.prototype, "onCancelButtonClick", void 0);
    __decorate([
        Output()
    ], ColorPanelComponent.prototype, "onCustomColorSelection", void 0);
    __decorate([
        Output()
    ], ColorPanelComponent.prototype, "onOkButtonClick", void 0);
    ColorPanelComponent = __decorate([
        Directive({
            exportAs: 'smart-color-panel', selector: 'smart-color-panel, [smart-color-panel]',
            providers: [CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
        })
    ], ColorPanelComponent);
    return ColorPanelComponent;
}(BaseElement));

var ColorPanelModule = /** @class */ (function () {
    function ColorPanelModule() {
    }
    ColorPanelModule = __decorate([
        NgModule({
            declarations: [ColorPanelComponent],
            schemas: [CUSTOM_ELEMENTS_SCHEMA],
            exports: [ColorPanelComponent]
        })
    ], ColorPanelModule);
    return ColorPanelModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { ColorPanelComponent, ColorPanelModule, Smart, BaseElement as ɵa };
//# sourceMappingURL=smart-webcomponents-angular-colorpanel.js.map
