
if (!window['Smart']) {
	window['Smart'] = { RenderMode: 'manual' };
}
else {
	window['Smart'].RenderMode = 'manual';
}
import './../source/modules/smart.gridpanel';

import { __decorate, __extends } from 'tslib';
import { EventEmitter, Output, Input, ElementRef, Directive, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';

var BaseElement = /** @class */ (function () {
    function BaseElement(ref) {
        this.onCreate = new EventEmitter();
        this.onReady = new EventEmitter();
        this.onAttach = new EventEmitter();
        this.onDetach = new EventEmitter();
        var that = this;
        this.nativeElement = ref.nativeElement;
        that.nativeElement.onAttached = function () {
            that.onAttach.emit(that.nativeElement);
        };
        that.nativeElement.onDetached = function () {
            that.onDetach.emit(that.nativeElement);
        };
    }
    BaseElement.prototype.addEventListener = function (type, listener, options) {
        if (options === void 0) { options = false; }
        this.nativeElement.addEventListener(type, listener, options);
    };
    BaseElement.prototype.removeEventListener = function (type, listener, options) {
        if (options === void 0) { options = false; }
        this.nativeElement.removeEventListener(type, listener, options);
    };
    BaseElement.prototype.dispatchEvent = function (event) {
        return this.nativeElement.dispatchEvent(event);
    };
    BaseElement.prototype.blur = function () {
        this.nativeElement.blur();
    };
    BaseElement.prototype.click = function () {
        this.nativeElement.click();
    };
    BaseElement.prototype.focus = function (options) {
        this.nativeElement.focus(options);
    };
    Object.defineProperty(BaseElement.prototype, "locale", {
        /** @description Sets or gets the language. Used in conjunction with the property messages.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.locale : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.locale = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "localizeFormatFunction", {
        /** @description Callback used to customize the format of the messages that are returned from the Localization Module. */
        get: function () {
            return this.nativeElement ? this.nativeElement.localizeFormatFunction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.localizeFormatFunction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "messages", {
        /** @description Sets or gets an object specifying strings used in the widget that can be localized. Used in conjunction with the property locale.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.messages : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.messages = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "rightToLeft", {
        /** @description Sets or gets the value indicating whether the element is aligned to support locales using right-to-left fonts. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rightToLeft : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rightToLeft = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "theme", {
        /** @description Determines the theme. Theme defines the look of the element */
        get: function () {
            return this.nativeElement ? this.nativeElement.theme : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.theme = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Output()
    ], BaseElement.prototype, "onCreate", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onReady", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onAttach", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onDetach", void 0);
    __decorate([
        Input()
    ], BaseElement.prototype, "locale", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "localizeFormatFunction", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "messages", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "rightToLeft", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "theme", null);
    return BaseElement;
}());
var Smart = window.Smart;

var MultiColumnFilterPanelComponent = /** @class */ (function (_super) {
    __extends(MultiColumnFilterPanelComponent, _super);
    function MultiColumnFilterPanelComponent(ref) {
        var _this = _super.call(this, ref) || this;
        _this.eventHandlers = [];
        /** @description This event is triggered when the "Apply" button is clicked.
        *  @param event. The custom event. 	*/
        _this.onApply = new EventEmitter();
        /** @description This event is triggered when the "Cancel" button is clicked.
        *  @param event. The custom event. 	*/
        _this.onCancel = new EventEmitter();
        /** @description This event is triggered when the "Collapse all" button is clicked.
        *  @param event. The custom event. 	*/
        _this.onCollapseAll = new EventEmitter();
        /** @description This event is triggered when the "Expand all" button is clicked.
        *  @param event. The custom event. 	*/
        _this.onExpandAll = new EventEmitter();
        _this.nativeElement = ref.nativeElement;
        return _this;
    }
    /** @description Creates the component on demand.
     * @param properties An optional object of properties, which will be added to the template binded ones.
     */
    MultiColumnFilterPanelComponent.prototype.createComponent = function (properties) {
        if (properties === void 0) { properties = {}; }
        this.nativeElement = document.createElement('smart-multi-column-filter-panel');
        for (var propertyName in properties) {
            this.nativeElement[propertyName] = properties[propertyName];
        }
        return this.nativeElement;
    };
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "animation", {
        /** @description Sets or gets the animation mode. Animation is disabled when the property is set to 'none' */
        get: function () {
            return this.nativeElement ? this.nativeElement.animation : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.animation = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "closeButtonPosition", {
        /** @description Sets or gets the position of the close button of multi column filter panel items. */
        get: function () {
            return this.nativeElement ? this.nativeElement.closeButtonPosition : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.closeButtonPosition = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "dataSource", {
        /** @description Determines the data source that will be loaded to the multi column filter panel.Each member of the dataSource array is an object with the following fields:dataField - the dataField of the column to be grouped.dataType - the data type of the column to be grouped.groupIndex - the group order of columns. If this value is -1, the grouping will not be applied by this column initially.label - the column label to be displayed in the column selection input.icon - a specific class to be applied to the respective item in the column selection input.sortDirection - the sort direction to be applied when grouping. Possible values: 'ascending' and 'descending'. */
        get: function () {
            return this.nativeElement ? this.nativeElement.dataSource : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.dataSource = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "disabled", {
        /** @description Enables or disables the multi column filter panel. */
        get: function () {
            return this.nativeElement ? this.nativeElement.disabled : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.disabled = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "editorCallback", {
        /** @description A callback function that can be used to modify the settings of value editors. */
        get: function () {
            return this.nativeElement ? this.nativeElement.editorCallback : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.editorCallback = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "editorPlaceholder", {
        /** @description Sets or gets the placeholder for the filter value editors. */
        get: function () {
            return this.nativeElement ? this.nativeElement.editorPlaceholder : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.editorPlaceholder = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "locale", {
        /** @description Sets or gets the language. Used in conjunction with the property messages. */
        get: function () {
            return this.nativeElement ? this.nativeElement.locale : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.locale = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "localizeFormatFunction", {
        /** @description Callback used to customize the format of the messages that are returned from the Localization Module. */
        get: function () {
            return this.nativeElement ? this.nativeElement.localizeFormatFunction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.localizeFormatFunction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "maxLevel", {
        /** @description Sets or gets the maximum number of columns to group by. If set to null, there is no limit. */
        get: function () {
            return this.nativeElement ? this.nativeElement.maxLevel : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.maxLevel = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "messages", {
        /** @description Sets or gets an object specifying strings used in the widget that can be localized. Used in conjunction with the property locale.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.messages : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.messages = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "operator", {
        /** @description Determines the logical operator between the items. */
        get: function () {
            return this.nativeElement ? this.nativeElement.operator : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.operator = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "readonly", {
        /** @description If the element is readonly, users cannot interact with it. */
        get: function () {
            return this.nativeElement ? this.nativeElement.readonly : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.readonly = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "rightToLeft", {
        /** @description Sets or gets the value indicating whether the element is aligned to support locales using right-to-left fonts. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rightToLeft : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rightToLeft = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "unfocusable", {
        /** @description If is set to true, the element cannot be focused. */
        get: function () {
            return this.nativeElement ? this.nativeElement.unfocusable : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.unfocusable = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "value", {
        /** @description Sets of gets the initial value of the element. */
        get: function () {
            return this.nativeElement ? this.nativeElement.value : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.value = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiColumnFilterPanelComponent.prototype, "isRendered", {
        get: function () {
            return this.nativeElement ? this.nativeElement.isRendered : false;
        },
        enumerable: true,
        configurable: true
    });
    MultiColumnFilterPanelComponent.prototype.ngOnInit = function () {
    };
    MultiColumnFilterPanelComponent.prototype.ngAfterViewInit = function () {
        var that = this;
        that.onCreate.emit(that.nativeElement);
        Smart.Render();
        this.nativeElement.classList.add('smart-angular');
        this.nativeElement.whenRendered(function () { that.onReady.emit(that.nativeElement); });
        this.listen();
    };
    MultiColumnFilterPanelComponent.prototype.ngOnDestroy = function () {
        this.unlisten();
    };
    MultiColumnFilterPanelComponent.prototype.ngOnChanges = function (changes) {
        if (this.nativeElement && this.nativeElement.isRendered) {
            for (var propName in changes) {
                if (changes.hasOwnProperty(propName)) {
                    this.nativeElement[propName] = changes[propName].currentValue;
                }
            }
        }
    };
    /** @description Add event listeners. */
    MultiColumnFilterPanelComponent.prototype.listen = function () {
        var that = this;
        that.eventHandlers['applyHandler'] = function (event) { that.onApply.emit(event); };
        that.nativeElement.addEventListener('apply', that.eventHandlers['applyHandler']);
        that.eventHandlers['cancelHandler'] = function (event) { that.onCancel.emit(event); };
        that.nativeElement.addEventListener('cancel', that.eventHandlers['cancelHandler']);
        that.eventHandlers['collapseAllHandler'] = function (event) { that.onCollapseAll.emit(event); };
        that.nativeElement.addEventListener('collapseAll', that.eventHandlers['collapseAllHandler']);
        that.eventHandlers['expandAllHandler'] = function (event) { that.onExpandAll.emit(event); };
        that.nativeElement.addEventListener('expandAll', that.eventHandlers['expandAllHandler']);
    };
    /** @description Remove event listeners. */
    MultiColumnFilterPanelComponent.prototype.unlisten = function () {
        var that = this;
        if (that.eventHandlers['applyHandler']) {
            that.nativeElement.removeEventListener('apply', that.eventHandlers['applyHandler']);
        }
        if (that.eventHandlers['cancelHandler']) {
            that.nativeElement.removeEventListener('cancel', that.eventHandlers['cancelHandler']);
        }
        if (that.eventHandlers['collapseAllHandler']) {
            that.nativeElement.removeEventListener('collapseAll', that.eventHandlers['collapseAllHandler']);
        }
        if (that.eventHandlers['expandAllHandler']) {
            that.nativeElement.removeEventListener('expandAll', that.eventHandlers['expandAllHandler']);
        }
    };
    MultiColumnFilterPanelComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "animation", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "closeButtonPosition", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "dataSource", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "disabled", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "editorCallback", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "editorPlaceholder", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "locale", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "localizeFormatFunction", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "maxLevel", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "messages", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "operator", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "readonly", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "rightToLeft", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "unfocusable", null);
    __decorate([
        Input()
    ], MultiColumnFilterPanelComponent.prototype, "value", null);
    __decorate([
        Output()
    ], MultiColumnFilterPanelComponent.prototype, "onApply", void 0);
    __decorate([
        Output()
    ], MultiColumnFilterPanelComponent.prototype, "onCancel", void 0);
    __decorate([
        Output()
    ], MultiColumnFilterPanelComponent.prototype, "onCollapseAll", void 0);
    __decorate([
        Output()
    ], MultiColumnFilterPanelComponent.prototype, "onExpandAll", void 0);
    MultiColumnFilterPanelComponent = __decorate([
        Directive({
            exportAs: 'smart-multi-column-filter-panel', selector: 'smart-multi-column-filter-panel, [smart-multi-column-filter-panel]'
        })
    ], MultiColumnFilterPanelComponent);
    return MultiColumnFilterPanelComponent;
}(BaseElement));

var MultiColumnFilterPanelModule = /** @class */ (function () {
    function MultiColumnFilterPanelModule() {
    }
    MultiColumnFilterPanelModule = __decorate([
        NgModule({
            declarations: [MultiColumnFilterPanelComponent],
            schemas: [CUSTOM_ELEMENTS_SCHEMA],
            exports: [MultiColumnFilterPanelComponent]
        })
    ], MultiColumnFilterPanelModule);
    return MultiColumnFilterPanelModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { MultiColumnFilterPanelComponent, MultiColumnFilterPanelModule, Smart, BaseElement as ɵa };
//# sourceMappingURL=smart-webcomponents-angular-multicolumnfilterpanel.js.map
