
if (!window['Smart']) {
	window['Smart'] = { RenderMode: 'manual' };
}
else {
	window['Smart'].RenderMode = 'manual';
}
import './../source/modules/smart.textbox';

import { __decorate, __extends } from 'tslib';
import { EventEmitter, Output, Input, forwardRef, ElementRef, Directive, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

var BaseElement = /** @class */ (function () {
    function BaseElement(ref) {
        this.onCreate = new EventEmitter();
        this.onReady = new EventEmitter();
        this.onAttach = new EventEmitter();
        this.onDetach = new EventEmitter();
        var that = this;
        this.nativeElement = ref.nativeElement;
        that.nativeElement.onAttached = function () {
            that.onAttach.emit(that.nativeElement);
        };
        that.nativeElement.onDetached = function () {
            that.onDetach.emit(that.nativeElement);
        };
    }
    BaseElement.prototype.addEventListener = function (type, listener, options) {
        if (options === void 0) { options = false; }
        this.nativeElement.addEventListener(type, listener, options);
    };
    BaseElement.prototype.removeEventListener = function (type, listener, options) {
        if (options === void 0) { options = false; }
        this.nativeElement.removeEventListener(type, listener, options);
    };
    BaseElement.prototype.dispatchEvent = function (event) {
        return this.nativeElement.dispatchEvent(event);
    };
    BaseElement.prototype.blur = function () {
        this.nativeElement.blur();
    };
    BaseElement.prototype.click = function () {
        this.nativeElement.click();
    };
    BaseElement.prototype.focus = function (options) {
        this.nativeElement.focus(options);
    };
    Object.defineProperty(BaseElement.prototype, "locale", {
        /** @description Sets or gets the language. Used in conjunction with the property messages.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.locale : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.locale = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "localizeFormatFunction", {
        /** @description Callback used to customize the format of the messages that are returned from the Localization Module. */
        get: function () {
            return this.nativeElement ? this.nativeElement.localizeFormatFunction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.localizeFormatFunction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "messages", {
        /** @description Sets or gets an object specifying strings used in the widget that can be localized. Used in conjunction with the property locale.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.messages : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.messages = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "rightToLeft", {
        /** @description Sets or gets the value indicating whether the element is aligned to support locales using right-to-left fonts. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rightToLeft : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rightToLeft = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseElement.prototype, "theme", {
        /** @description Determines the theme. Theme defines the look of the element */
        get: function () {
            return this.nativeElement ? this.nativeElement.theme : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.theme = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Output()
    ], BaseElement.prototype, "onCreate", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onReady", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onAttach", void 0);
    __decorate([
        Output()
    ], BaseElement.prototype, "onDetach", void 0);
    __decorate([
        Input()
    ], BaseElement.prototype, "locale", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "localizeFormatFunction", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "messages", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "rightToLeft", null);
    __decorate([
        Input()
    ], BaseElement.prototype, "theme", null);
    return BaseElement;
}());
var Smart = window.Smart;

var CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(function () { return PasswordTextBoxComponent; }),
    multi: true
};
var PasswordTextBoxComponent = /** @class */ (function (_super) {
    __extends(PasswordTextBoxComponent, _super);
    function PasswordTextBoxComponent(ref) {
        var _this = _super.call(this, ref) || this;
        _this.eventHandlers = [];
        /**
        * @description
        * The registered callback function called when a change event occurs on the form elements.
        */
        _this._onChange = function () { };
        /**
        * @description
        * The registered callback function called when a blur event occurs on the form elements.
        */
        _this._onTouched = function () { };
        /** @description This event is triggered when the value of the element is changed.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	oldValue, 	value)
        *   oldValue - The previous value of the element before it was changed.
        *   value - The new value of the element.
        */
        _this.onChange = new EventEmitter();
        /** @description This event is triggered on each key up event of the TextBox, if the value is changed.
        *  @param event. The custom event. 	Custom event was created with: event.detail(	oldValue, 	value)
        *   oldValue - The previous value before it was changed.
        *   value - The new value.
        */
        _this.onChanging = new EventEmitter();
        _this._initialChange = true;
        _this.nativeElement = ref.nativeElement;
        return _this;
    }
    /** @description Creates the component on demand.
     * @param properties An optional object of properties, which will be added to the template binded ones.
     */
    PasswordTextBoxComponent.prototype.createComponent = function (properties) {
        if (properties === void 0) { properties = {}; }
        this.nativeElement = document.createElement('smart-password-text-box');
        for (var propertyName in properties) {
            this.nativeElement[propertyName] = properties[propertyName];
        }
        return this.nativeElement;
    };
    Object.defineProperty(PasswordTextBoxComponent.prototype, "animation", {
        /** @description Sets or gets the animation mode. Animation is disabled when the property is set to 'none' */
        get: function () {
            return this.nativeElement ? this.nativeElement.animation : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.animation = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "autoFocus", {
        /** @description Specifies that the element should be focused when the page is loaded. */
        get: function () {
            return this.nativeElement ? this.nativeElement.autoFocus : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.autoFocus = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "disabled", {
        /** @description Enables or disables the element. */
        get: function () {
            return this.nativeElement ? this.nativeElement.disabled : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.disabled = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "enterKeyBehavior", {
        /** @description Specifies the behavior on "Enter" key press. Default mode is "submit". */
        get: function () {
            return this.nativeElement ? this.nativeElement.enterKeyBehavior : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.enterKeyBehavior = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "form", {
        /** @description The form that the element is associated with (its "form owner"). The value of the attribute must be the ID of a form element in the same document. */
        get: function () {
            return this.nativeElement ? this.nativeElement.form : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.form = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "hint", {
        /** @description Sets additional helper text below the element. Appears only when the element is focused. */
        get: function () {
            return this.nativeElement ? this.nativeElement.hint : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.hint = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "label", {
        /** @description Sets label above the element. The label is displayed above the input and it's always visible. */
        get: function () {
            return this.nativeElement ? this.nativeElement.label : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.label = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "locale", {
        /** @description Sets or gets the language. Used in conjunction with the property messages.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.locale : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.locale = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "localizeFormatFunction", {
        /** @description Callback used to customize the format of the messages that are returned from the Localization Module. */
        get: function () {
            return this.nativeElement ? this.nativeElement.localizeFormatFunction : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.localizeFormatFunction = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "maxLength", {
        /** @description Sets or gets the maximum number of characters that the user can enter. */
        get: function () {
            return this.nativeElement ? this.nativeElement.maxLength : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.maxLength = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "messages", {
        /** @description Sets an object with string values, related to the different states of passwords strength. */
        get: function () {
            return this.nativeElement ? this.nativeElement.messages : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.messages = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "minLength", {
        /** @description Sets or gets the minimum number of characters that the user can enter. */
        get: function () {
            return this.nativeElement ? this.nativeElement.minLength : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.minLength = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "name", {
        /** @description Sets or gets the name attribute for the element. Name is used when submiting HTML forms. */
        get: function () {
            return this.nativeElement ? this.nativeElement.name : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.name = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "passwordStrength", {
        /** @description With this property the user can set a custom callback function that determines the password strength. The returned string from the function determines the how strong the current password is. The string should be one of the following: 'short', 'weak', 'far', 'good', 'strong'. */
        get: function () {
            return this.nativeElement ? this.nativeElement.passwordStrength : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.passwordStrength = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "placeholder", {
        /** @description The placeholder text that is displayed when no value is applied to the element.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.placeholder : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.placeholder = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "required", {
        /** @description Specifies that the user must fill in a value before submitting a form that contains the element. */
        get: function () {
            return this.nativeElement ? this.nativeElement.required : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.required = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "rightToLeft", {
        /** @description Sets or gets the value indicating whether the element is aligned to support locales using right-to-left fonts. */
        get: function () {
            return this.nativeElement ? this.nativeElement.rightToLeft : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.rightToLeft = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "selectAllOnFocus", {
        /** @description Specifies whether the content of the input will be selected on focus. */
        get: function () {
            return this.nativeElement ? this.nativeElement.selectAllOnFocus : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.selectAllOnFocus = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "showPasswordIcon", {
        /** @description Determines whether the password icon is visible. */
        get: function () {
            return this.nativeElement ? this.nativeElement.showPasswordIcon : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.showPasswordIcon = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "showPasswordStrength", {
        /** @description Determines whether a tooltip which shows the password's strength will be shown. */
        get: function () {
            return this.nativeElement ? this.nativeElement.showPasswordStrength : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.showPasswordStrength = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "theme", {
        /** @description Determines the theme. Theme defines the look of the element */
        get: function () {
            return this.nativeElement ? this.nativeElement.theme : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.theme = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "tooltipArrow", {
        /** @description Determines whether Tooltip's arrow will be shown or not. */
        get: function () {
            return this.nativeElement ? this.nativeElement.tooltipArrow : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.tooltipArrow = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "tooltipDelay", {
        /** @description Determines the delay before the tooltip appears in miliseconds. */
        get: function () {
            return this.nativeElement ? this.nativeElement.tooltipDelay : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.tooltipDelay = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "tooltipPosition", {
        /** @description Determines the position of the tooltip. */
        get: function () {
            return this.nativeElement ? this.nativeElement.tooltipPosition : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.tooltipPosition = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "tooltipTemplate", {
        /** @description Sets a custom template for the content of the tooltip. */
        get: function () {
            return this.nativeElement ? this.nativeElement.tooltipTemplate : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.tooltipTemplate = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "unfocusable", {
        /** @description If true, the element cannot be focused. */
        get: function () {
            return this.nativeElement ? this.nativeElement.unfocusable : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.unfocusable = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PasswordTextBoxComponent.prototype, "value", {
        /** @description Sets or gets the value of the element.  */
        get: function () {
            return this.nativeElement ? this.nativeElement.value : undefined;
        },
        set: function (value) {
            this.nativeElement ? this.nativeElement.value = value : undefined;
        },
        enumerable: true,
        configurable: true
    });
    /** @description Focuses the element.
    */
    PasswordTextBoxComponent.prototype.focus = function () {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.focus();
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.focus();
            });
        }
    };
    /** @description The method is used to reset input to it's initial value.
    */
    PasswordTextBoxComponent.prototype.reset = function () {
        var _this = this;
        if (this.nativeElement.isRendered) {
            this.nativeElement.reset();
        }
        else {
            this.nativeElement.whenRendered(function () {
                _this.nativeElement.reset();
            });
        }
    };
    Object.defineProperty(PasswordTextBoxComponent.prototype, "isRendered", {
        get: function () {
            return this.nativeElement ? this.nativeElement.isRendered : false;
        },
        enumerable: true,
        configurable: true
    });
    PasswordTextBoxComponent.prototype.ngOnInit = function () {
    };
    PasswordTextBoxComponent.prototype.ngAfterViewInit = function () {
        var that = this;
        that.onCreate.emit(that.nativeElement);
        Smart.Render();
        this.nativeElement.classList.add('smart-angular');
        this.nativeElement.whenRendered(function () { that.onReady.emit(that.nativeElement); });
        this.listen();
    };
    PasswordTextBoxComponent.prototype.ngOnDestroy = function () {
        this.unlisten();
    };
    Object.defineProperty(PasswordTextBoxComponent.prototype, "ngValue", {
        get: function () {
            if (!this.nativeElement) {
                return null;
            }
            var value = this.nativeElement.value;
            return value;
        },
        set: function (value) {
            if (this.nativeElement) {
                this.writeValue(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    PasswordTextBoxComponent.prototype.writeValue = function (value) {
        var that = this;
        var normalizedValue = value == null ? '' : value;
        that.nativeElement.whenRendered(function () {
            that.value = normalizedValue;
            if (that._initialChange === false) {
                that._onChange(that.value);
            }
        });
    };
    PasswordTextBoxComponent.prototype.registerOnChange = function (fn) {
        this._onChange = fn;
    };
    PasswordTextBoxComponent.prototype.registerOnTouched = function (fn) {
        this._onTouched = fn;
    };
    PasswordTextBoxComponent.prototype.ngOnChanges = function (changes) {
        if (this.nativeElement && this.nativeElement.isRendered) {
            for (var propName in changes) {
                if (changes.hasOwnProperty(propName)) {
                    this.nativeElement[propName] = changes[propName].currentValue;
                }
            }
        }
    };
    /** @description Add event listeners. */
    PasswordTextBoxComponent.prototype.listen = function () {
        var that = this;
        that.eventHandlers['changeHandler'] = function (event) { that.onChange.emit(event); };
        that.nativeElement.addEventListener('change', that.eventHandlers['changeHandler']);
        that.eventHandlers['changingHandler'] = function (event) { that.onChanging.emit(event); };
        that.nativeElement.addEventListener('changing', that.eventHandlers['changingHandler']);
        that.eventHandlers['changeModelHandler'] = function (event) {
            that._initialChange = false;
            that._onChange(that.nativeElement.value);
        };
        that.eventHandlers['blurModelHandler'] = function (event) {
            that._onTouched();
        };
        that.nativeElement.whenRendered(function () {
            if (that.nativeElement.querySelector('input')) {
                that.eventHandlers['keyupModelHandler'] = function (event) {
                    setTimeout(function () { that.eventHandlers['changeModelHandler'](event); }, 50);
                };
                that.nativeElement.querySelector('input').addEventListener('keyup', that.eventHandlers['keyupModelHandler']);
            }
        });
        that.nativeElement.addEventListener('change', that.eventHandlers['changeModelHandler']);
        that.nativeElement.addEventListener('blur', that.eventHandlers['blurModelHandler']);
    };
    /** @description Remove event listeners. */
    PasswordTextBoxComponent.prototype.unlisten = function () {
        var that = this;
        if (that.eventHandlers['changeHandler']) {
            that.nativeElement.removeEventListener('change', that.eventHandlers['changeHandler']);
        }
        if (that.eventHandlers['changingHandler']) {
            that.nativeElement.removeEventListener('changing', that.eventHandlers['changingHandler']);
        }
        if (that.eventHandlers['changeModelHandler']) {
            that.nativeElement.removeEventListener('change', that.eventHandlers['changeModelHandler']);
            if (that.nativeElement.querySelector('input')) {
                that.nativeElement.querySelector('input').removeEventListener('keyup', that.eventHandlers['keyupModelHandler']);
            }
        }
        if (that.eventHandlers['blurModelHandler']) {
            that.nativeElement.removeEventListener('blur', that.eventHandlers['blurModelHandler']);
        }
    };
    PasswordTextBoxComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "animation", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "autoFocus", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "disabled", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "enterKeyBehavior", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "form", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "hint", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "label", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "locale", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "localizeFormatFunction", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "maxLength", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "messages", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "minLength", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "name", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "passwordStrength", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "placeholder", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "required", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "rightToLeft", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "selectAllOnFocus", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "showPasswordIcon", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "showPasswordStrength", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "theme", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "tooltipArrow", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "tooltipDelay", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "tooltipPosition", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "tooltipTemplate", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "unfocusable", null);
    __decorate([
        Input()
    ], PasswordTextBoxComponent.prototype, "value", null);
    __decorate([
        Output()
    ], PasswordTextBoxComponent.prototype, "onChange", void 0);
    __decorate([
        Output()
    ], PasswordTextBoxComponent.prototype, "onChanging", void 0);
    PasswordTextBoxComponent = __decorate([
        Directive({
            exportAs: 'smart-password-text-box', selector: 'smart-password-text-box, [smart-password-text-box]',
            providers: [CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
        })
    ], PasswordTextBoxComponent);
    return PasswordTextBoxComponent;
}(BaseElement));

var PasswordTextBoxModule = /** @class */ (function () {
    function PasswordTextBoxModule() {
    }
    PasswordTextBoxModule = __decorate([
        NgModule({
            declarations: [PasswordTextBoxComponent],
            schemas: [CUSTOM_ELEMENTS_SCHEMA],
            exports: [PasswordTextBoxComponent]
        })
    ], PasswordTextBoxModule);
    return PasswordTextBoxModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { PasswordTextBoxComponent, PasswordTextBoxModule, Smart, BaseElement as ɵa };
//# sourceMappingURL=smart-webcomponents-angular-passwordtextbox.js.map
